#!/usr/bin/python3

import os
import sys
import re

def parse_capture(filename):
    f = open('measurements/' + filename)
    #counter = 0
    counter = 1
    lets_use_a_flag = False
    six_ts = ''
    two_ts = ''
    enc_deltas = {}
    dec_deltas = {}
    for l in f.readlines():
        l_array = l.split(" ")
        bit_field = l_array[-1][:-1]
        # l_array? That's the best you came up with?
        if bit_field == '6':
            six_ts = l_array[0][:-1]
            lets_use_a_flag = True
            continue
        if lets_use_a_flag:
            if bit_field == '2':
                #if counter == 0:
                    #counter = counter + 1
                    #continue
                two_ts = l_array[0][:-1]
                delta = float(two_ts) - float(six_ts)
                if counter % 2 == 1:
                    enc_deltas[(counter+1)/2] = delta
                else:
                    dec_deltas[counter/2] = delta
                counter = counter + 1
            else:
                lets_use_a_flag = False
    f.close()
    for key in enc_deltas:
        print("Vector %d was encrypted in %f seconds" % (key, enc_deltas[key]))
    for key in dec_deltas:
        print("Vector %d was decrypted in %f seconds" % (key, dec_deltas[key]))
    print(len(enc_deltas))
    print(len(dec_deltas))

def read_log(d):
    # Soo readlines, much efficient
    f = open(d + '/test_stdout.log', 'r')
    content = f.readlines()
    
    are_we_happy = content[-1].split(' ')[-1]
    if are_we_happy != 'SUCCESSFUL\n':
        print ("Test unsuccesful or log file structure corrupted")
        return
    
    # I like to split it, split it 
    algorithm = content[0].split(' ')[-1].split('/')[-2]
    # Path to logic data is in the second to last line
    logic_file = content[-2].split('/')[-1][:-2]
    
    f. close()
    
    print("Let's evaluate the test results of algorithm %s by using %s" % (algorithm, logic_file))
        
    parse_capture(logic_file)

def main():
    print('THE LWC BENCHMARK SPLITTER')
    print('powered by Deutsche Bahn')
    build_dir = 'build/'
    for d in os.listdir(build_dir):
        read_log(os.path.join(build_dir + d))



if __name__ == "__main__":
    main()

